// Generated by gencpp from file abb_rapid_msgs/LoadData.msg
// DO NOT EDIT!


#ifndef ABB_RAPID_MSGS_MESSAGE_LOADDATA_H
#define ABB_RAPID_MSGS_MESSAGE_LOADDATA_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <abb_rapid_msgs/Pos.h>
#include <abb_rapid_msgs/Orient.h>

namespace abb_rapid_msgs
{
template <class ContainerAllocator>
struct LoadData_
{
  typedef LoadData_<ContainerAllocator> Type;

  LoadData_()
    : mass(0.0)
    , cog()
    , aom()
    , ix(0.0)
    , iy(0.0)
    , iz(0.0)  {
    }
  LoadData_(const ContainerAllocator& _alloc)
    : mass(0.0)
    , cog(_alloc)
    , aom(_alloc)
    , ix(0.0)
    , iy(0.0)
    , iz(0.0)  {
  (void)_alloc;
    }



   typedef float _mass_type;
  _mass_type mass;

   typedef  ::abb_rapid_msgs::Pos_<ContainerAllocator>  _cog_type;
  _cog_type cog;

   typedef  ::abb_rapid_msgs::Orient_<ContainerAllocator>  _aom_type;
  _aom_type aom;

   typedef float _ix_type;
  _ix_type ix;

   typedef float _iy_type;
  _iy_type iy;

   typedef float _iz_type;
  _iz_type iz;





  typedef boost::shared_ptr< ::abb_rapid_msgs::LoadData_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::abb_rapid_msgs::LoadData_<ContainerAllocator> const> ConstPtr;

}; // struct LoadData_

typedef ::abb_rapid_msgs::LoadData_<std::allocator<void> > LoadData;

typedef boost::shared_ptr< ::abb_rapid_msgs::LoadData > LoadDataPtr;
typedef boost::shared_ptr< ::abb_rapid_msgs::LoadData const> LoadDataConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::abb_rapid_msgs::LoadData_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::abb_rapid_msgs::LoadData_<ContainerAllocator1> & lhs, const ::abb_rapid_msgs::LoadData_<ContainerAllocator2> & rhs)
{
  return lhs.mass == rhs.mass &&
    lhs.cog == rhs.cog &&
    lhs.aom == rhs.aom &&
    lhs.ix == rhs.ix &&
    lhs.iy == rhs.iy &&
    lhs.iz == rhs.iz;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::abb_rapid_msgs::LoadData_<ContainerAllocator1> & lhs, const ::abb_rapid_msgs::LoadData_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace abb_rapid_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::abb_rapid_msgs::LoadData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::abb_rapid_msgs::LoadData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::abb_rapid_msgs::LoadData_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dfe575484752eff5e837f54d2fd939e4";
  }

  static const char* value(const ::abb_rapid_msgs::LoadData_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xdfe575484752eff5ULL;
  static const uint64_t static_value2 = 0xe837f54d2fd939e4ULL;
};

template<class ContainerAllocator>
struct DataType< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "abb_rapid_msgs/LoadData";
  }

  static const char* value(const ::abb_rapid_msgs::LoadData_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#-------------------------------------------------------------------------------\n"
"# Description:\n"
"#   The purpose of this message definition, is to represent the\n"
"#   RAPID data type \"loaddata\" (load data).\n"
"#\n"
"# Note:\n"
"#   Please see the \"Technical reference manual - RAPID Instructions,\n"
"#   Functions and Data types\" for more details.\n"
"#-------------------------------------------------------------------------------\n"
"\n"
"#-------------------------------------------------------------------------------\n"
"# Message fields\n"
"#-------------------------------------------------------------------------------\n"
"# The mass (weight) of the load in kg.\n"
"float32 mass\n"
"\n"
"# The center of gravity of the payload, expressed in mm,\n"
"# in the tool coordinate system if the robot is holding the tool.\n"
"#\n"
"# If a stationary tool is used then the center of gravity for the payload\n"
"# held by the gripper is expressed in the object frame of the work object\n"
"# coordinate system moved by the robot.\n"
"Pos cog\n"
"\n"
"# The orientation of the axes of moment.\n"
"#\n"
"# These are the principal axes of the payload\n"
"# moment of inertia with origin in cog.\n"
"#\n"
"# If the robot is holding the tool, the axes of moment\n"
"# are expressed in the tool coordinate system.\n"
"Orient aom\n"
"\n"
"# The moment of inertia of the load around the x-, y- and z-axis,\n"
"# expressed in kgm^2.\n"
"float32 ix\n"
"float32 iy\n"
"float32 iz\n"
"\n"
"================================================================================\n"
"MSG: abb_rapid_msgs/Pos\n"
"#-------------------------------------------------------------------------------\n"
"# Description:\n"
"#   The purpose of this message definition, is to represent the\n"
"#   RAPID data type \"pos\" (positions (only X, Y and Z)).\n"
"#\n"
"# Note:\n"
"#   Please see the \"Technical reference manual - RAPID Instructions,\n"
"#   Functions and Data types\" for more details.\n"
"#-------------------------------------------------------------------------------\n"
"\n"
"#-------------------------------------------------------------------------------\n"
"# Message fields\n"
"#-------------------------------------------------------------------------------\n"
"# The x-, y- and z-value of the position.\n"
"float32 x\n"
"float32 y\n"
"float32 z\n"
"\n"
"================================================================================\n"
"MSG: abb_rapid_msgs/Orient\n"
"#-------------------------------------------------------------------------------\n"
"# Description:\n"
"#   The purpose of this message definition, is to represent the\n"
"#   RAPID data type \"orient\" (orientation).\n"
"#\n"
"# Note:\n"
"#   Please see the \"Technical reference manual - RAPID Instructions,\n"
"#   Functions and Data types\" for more details.\n"
"#-------------------------------------------------------------------------------\n"
"\n"
"#-------------------------------------------------------------------------------\n"
"# Message fields\n"
"#-------------------------------------------------------------------------------\n"
"# Quaternion 1-4.\n"
"float32 q1\n"
"float32 q2\n"
"float32 q3\n"
"float32 q4\n"
;
  }

  static const char* value(const ::abb_rapid_msgs::LoadData_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.mass);
      stream.next(m.cog);
      stream.next(m.aom);
      stream.next(m.ix);
      stream.next(m.iy);
      stream.next(m.iz);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct LoadData_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::abb_rapid_msgs::LoadData_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::abb_rapid_msgs::LoadData_<ContainerAllocator>& v)
  {
    s << indent << "mass: ";
    Printer<float>::stream(s, indent + "  ", v.mass);
    s << indent << "cog: ";
    s << std::endl;
    Printer< ::abb_rapid_msgs::Pos_<ContainerAllocator> >::stream(s, indent + "  ", v.cog);
    s << indent << "aom: ";
    s << std::endl;
    Printer< ::abb_rapid_msgs::Orient_<ContainerAllocator> >::stream(s, indent + "  ", v.aom);
    s << indent << "ix: ";
    Printer<float>::stream(s, indent + "  ", v.ix);
    s << indent << "iy: ";
    Printer<float>::stream(s, indent + "  ", v.iy);
    s << indent << "iz: ";
    Printer<float>::stream(s, indent + "  ", v.iz);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ABB_RAPID_MSGS_MESSAGE_LOADDATA_H
